<?php
require_once("rss_parser.php");
$version = substr($settings['version'], 0, 1);
	if ($version == "7") {
		if (!isset($prefix)) {
			$prefix = $db_prefix;
		};
		if (!defined("PREFIX")) {
			DEFINE("PREFIX", $db_prefix);
		};
	} else {
		if (!isset($prefix)) {
			$prefix = "";
		};
		if (!defined("PREFIX")) {
			DEFINE("PREFIX", "");
		};
	};

function Utf8ToWin($fcontents) {
    $out = $c1 = '';
    $byte2 = false;
    for ($c = 0;$c < strlen($fcontents);$c++) {
        $i = ord($fcontents[$c]);
        if ($i <= 127) {
            $out .= $fcontents[$c];
        }
        if ($byte2) {
            $new_c2 = ($c1 & 3) * 64 + ($i & 63);
            $new_c1 = ($c1 >> 2) & 5;
            $new_i = $new_c1 * 256 + $new_c2;
            if ($new_i == 1025) {
                $out_i = 168;
            } else {
                if ($new_i == 1105) {
                    $out_i = 184;
                } else {
                    $out_i = $new_i - 848;
                }
            }
            // UKRAINIAN fix
            switch ($out_i){
                case 262: $out_i=179;break;// 
                case 182: $out_i=178;break;// 
                case 260: $out_i=186;break;// 
                case 180: $out_i=170;break;// 
                case 263: $out_i=191;break;// 
                case 183: $out_i=175;break;// 
                case 321: $out_i=180;break;// 
                case 320: $out_i=165;break;// 
            }
            $out .= chr($out_i);
           
            $byte2 = false;
        }
        if ( ( $i >> 5) == 6) {
            $c1 = $i;
            $byte2 = true;
        }
    }
    return $out;
};

function WinToUtf8($s)    {
   for($i=0, $m=strlen($s); $i<$m; $i++)    {
       $c=ord($s[$i]);
       if ($c<=127) {$t.=chr($c); continue; }
       if ($c>=192 && $c<=207)    {$t.=chr(208).chr($c-48); continue; }
       if ($c>=208 && $c<=239) {$t.=chr(208).chr($c-48); continue; }
       if ($c>=240 && $c<=255) {$t.=chr(209).chr($c-112); continue; }
       if ($c==184) { $t.=chr(209).chr(209); continue; };
            if ($c==168) { $t.=chr(208).chr(129);  continue; };
            if ($c==184) { $t.=chr(209).chr(145); continue; }; #
            if ($c==168) { $t.=chr(208).chr(129); continue; }; #
            if ($c==179) { $t.=chr(209).chr(150); continue; }; #
            if ($c==178) { $t.=chr(208).chr(134); continue; }; #
            if ($c==191) { $t.=chr(209).chr(151); continue; }; #
            if ($c==175) { $t.=chr(208).chr(135); continue; }; #
            if ($c==186) { $t.=chr(209).chr(148); continue; }; #
            if ($c==170) { $t.=chr(208).chr(132); continue; }; #
            if ($c==180) { $t.=chr(210).chr(145); continue; }; #
            if ($c==165) { $t.=chr(210).chr(144); continue; }; #
            if ($c==184) { $t.=chr(209).chr(145); continue; }; #           
   }
   return $t;
};

function AutoConvert($source_text, $cp_from, $cp_to) {
	if ($cp_from == $cp_to) {
		$result = $source_text;
	} elseif ($cp_from == "utf-8") {
	   $result = AutoConvert(Utf8ToWin($source_text), "cp1251", $cp_to);
	} elseif ($cp_to == "utf-8") {
	   $result = WinToUtf8(AutoConvert($source_text, $cp_from, "cp1251"));
	} else {
		switch ($cp_from) {
		  case "cp1251":
			$c_from = "w";
			break;
		  case "cp866":
			$c_from = "d";
			break;
		  case "koi8-r":
			$c_from = "k";
			break;
		};
		switch ($cp_to) {
		  case "cp1251":
			$c_to = "w";
			break;
		  case "cp866":
			$c_to = "d";
			break;
		  case "koi8-r":
			$c_to = "k";
			break;
		};
		$result = convert_cyr_string($source_text, $c_from, $c_to);
	};
	return $result;
};

function ParseFeed($feed) {
	$parser = new rssParser;
	$result = dbquery("select rss_feed_url, rss_feed_display_count, rss_feed_codepage from ".DB_PREFIX."rss_feeds where rss_feed_id='$feed'");
	if (dbrows($result) > 0) {
		$settings = dbarray(dbquery("select rss_result_codepage from ".DB_PREFIX."rss_settings"));
		$cp_result = $settings['rss_result_codepage'];
		$data = dbarray($result);
		$parser->parse($data['rss_feed_url']);
		if (count($parser->items) > 0) {
			$result = dbquery("delete from ".DB_PREFIX."rss_items where rss_item_feed='$feed'");
			$i = 1;
			foreach($parser->items as $rss_item) {
				if ($i <= $data['rss_feed_display_count'] || $data['rss_feed_display_count'] == 0) {
					$result = dbquery("insert into ".DB_PREFIX."rss_items values ('$feed', '$i', '".addslashes(AutoConvert($rss_item['title'], $data['rss_feed_codepage'], $cp_result))."', '".addslashes(AutoConvert($rss_item['description'], $data['rss_feed_codepage'], $cp_result))."', '".addslashes($rss_item['link'])."', '".strtotime($rss_item['pubDate'])."')");
				};
				$i++;
			};
			$result = dbquery("update ".DB_PREFIX."rss_feeds set rss_feed_last_updated=".time()." where rss_feed_id=".$feed);
		};
	};
};

function CheckFeeds() {
	$result = dbquery("select rss_feed_id, rss_feed_update, rss_feed_last_updated from ".DB_PREFIX."rss_feeds");
	while ($data = dbarray($result)) {
		if ($data['rss_feed_last_updated'] + $data['rss_feed_update'] < time()) {
			ParseFeed($data['rss_feed_id']);
		};
	};
};
?>